#ifndef TDA1004X
#define TDA1004X 1

#include <linux/dvb/frontend.h>
#include <linux/firmware.h>
#include "dvbdev.h"

struct tda1004x_cardspec 
{   
	// public fields
	int (*demod_write) (struct tda1004x_cardspec* cardspec, const u8 reg, const u8* buf, int len);
	int (*demod_read) (struct tda1004x_cardspec* cardspec, const u8 reg, const u8* buf, int len);
	int (*pll_init) (struct tda1004x_cardspec* cardspec);
	int (*pll_set) (struct tda1004x_cardspec* cardspec, struct dvb_frontend_parameters* fe);
	int (*request_firmware) (struct tda1004x_cardspec* cardspec, const struct firmware **fw, const char* name);
   
	u8 inversion:1;

	// internal fields	
	u8 demod_type;
	u8 initialised:1;
	int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg);
	struct dvb_adapter *adapter;
	void* data;
};


int tda10045_init(struct tda1004x_cardspec* cardspec,
		  int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg),
		  struct dvb_adapter *dvb_adapter,
		  void *data);

int tda10046_init(struct tda1004x_cardspec* cardspec,
		  int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg),
		  struct dvb_adapter *dvb_adapter,
		  void *data);

int tda1004x_shutdown(struct tda1004x_cardspec* cardspec);

int tda1004x_ioctl(struct tda1004x_cardspec* cardspec, struct dvb_frontend *fe, unsigned int cmd, void *arg);

#endif
